import $ from 'jquery';
import moment from 'moment'
import './styles.scss'
import Editor from './editor'
import MD from './markdown'

moment.locale('nl')
// mermaid.initialize({startOnLoad: true})
// PrismJS.plugins.filterHighlightAll.reject.addSelector('.language-mermaid')
// PrismJS.plugins.filterHighlightAll.reject.addSelector('.language-dot')

// $(function () {
//     wikiGraph('.graph-network')
// })

/*
 * EVENTS
 */
$(document).on('keydown', '.keyboard-list', function (event) {
    if (!$(':visible', this).length) {
        return true
    }

    const $popup = $(this)
    if (event.key === 'Escape') {
        $popup.fadeOut()
        return false
    }

    return true
})

$(document).on('keydown', '#search-input', function (event) {
    let $ac = $('#autocomplete');
    let isVisible = $(':visible', $ac)
    if (event.key === 'ArrowDown' && isVisible) {
        $ac.focus()
        $ac.find('li:first-child').addClass('selected')
        return false
    }
    if (event.key === 'Escape') {
        $(searchInput).val('');
        $ac.fadeOut();
        return false;
    }
    return true
})

$(document).on('popup:selected', '#autocomplete', function (event, linkName, resultType, element) {
    if (resultType === 'search-result') {
        element.find('a')[0].click()
        return false;
    }
})

document.querySelectorAll(".page-loader")
    .forEach((el, key, parent) => {
        let format = el.dataset.format
        let edit = el.dataset.edit
        fetch('/' + el.dataset.page + '?format=' + format)
            .then(res => edit ? res.json() : res.text())
            .then(text => {
                if (edit) {
                    new Editor(el, text).then(editor => editor.start());
                } else {
                    el.innerHTML = MD.render(text)
                }
            })
    })
